/*	
 *	Pollin Electronic GmbH
 *	Max-Pollin-Strae 1			
 *	85104 Pfrring 
 *	http://www.pollin.de
 *
 *	Project:	RAPITUS SAMxS Evaluationboard 
 *  Filename:	dcf.h 
 *
 *  Author:		Leonhard Hesse
 *
 *  Copyright (c) 2016 Pollin Electronic GmbH. All rights reserved.
 *
 *  Bitte beachten Sie, dass dieses Programm nur uneingeschrnkt fr nicht kommerzielle Zwecke genutzt 
 *  werden darf. Ich bernehme keine Garantie fr die einwandfreie Funktion dieses Programmes und ber- 
 *  nehme dadurch auch keine Haftung fr Folgeschden die Aufgrund der Benutzung dieser Daten entstehen. 
 *  Dieses gilt auch dann, wenn ich ber einen solchen Schaden unterrichtet worden bin. 
 */

#ifndef DCF_H_
#define DCF_H_

#define DCF_STARTUPTIME		3000	//3sek
#define DCF_SIGNAL_TEST		10100	//10,1sek
#define MESSAGE_DELAY		5100	//5,1sek

/* Bit Masks */
#define DCF_BIT1_MASK			0x00
#define DCF_BIT2_MASK			0x01
#define DCF_BIT3_MASK			0x02
#define DCF_BIT4_MASK			0x03
#define DCF_BIT5_MASK			0x04
#define DCF_BIT6_MASK			0x05
#define DCF_BIT7_MASK			0x06
#define DCF_BIT8_MASK			0x07
#define DCF_MIN_PARI_MASK		0x07
#define DCF_H_PARI_MASK			0x06
#define DCF_MIN_UNITS_MASK		0x0F
#define DCF_MIN_TENS_MASK		0x70
#define DCF_MIN_MASK			0x7F
#define DCF_H_UNITS_MASK		0x0F
#define DCF_H_TENS_MASK			0x30
#define DCF_H_MASK				0x3F
#define DCF_DAY_UNITS_MASK		0x0F
#define DCF_DAY_TENS_MASK		0x30
#define DCF_MONTH_UNITS_MASK	0x0F
#define DCF_MONTH_TENS_MASK		0x30
#define DCF_YEAR_UNITS_MASK		0x0F
#define DCF_YEAR_TENS_MASK		0xF0

#include "asf.h"

void updateTime(void);
void updateDate(void);
void dcf_init(void);
void dcf_stop(void);
void dcf_data_handler(uint32_t id, uint32_t index);
void getReceivedBit(void);
bool checkParity(uint8_t parity, uint32_t data);
bool checkParityTime(void);
bool checkParityDate(void);

uint8_t dcf_bitCounter;
uint8_t dcf_detectBitCounter;
uint8_t dcf_detectedBit;
uint8_t dcf_receivedData_min;
uint8_t dcf_receivedData_h;
uint8_t dcf_receivedData_date_day;
uint8_t dcf_receivedData_date_month;
uint8_t dcf_receivedData_date_year;
uint8_t dcf_receivedData_weekday;
uint8_t dcf_receivedData_parity_date;
uint8_t dcf_validSignalCounter;
uint8_t dcf_messageDelayCounter;

uint16_t dcf_syncCounter;
uint16_t dcf_errorDetection;
uint16_t dcf_signalTestCounter;
uint16_t dcf_showMessageDelay;

uint32_t dcf_startup;

bool dcf_invalidSignal;
bool dcf_synced;
bool dcf_signalTestProcess;
bool dcf_signalTestResult;
bool dcf_signalTestDetection;
bool dcf_validTimeReceived;
bool dcf_validDateReceived;
bool dcf_invalidSync;
bool dcf_completed;

#endif /* DCF_H_ */