/*	
*	Pollin Electronic GmbH
*	Max-Pollin-Strae 1			
*	85104 Pfrring 
*	http://www.pollin.de
*
*	Project:	RAPITUS SAMxS Evaluationboard 
*	Filename:	rfm.h 
*
*	Author:		Leonhard Hesse
*
*	Copyright (c) 2016 Pollin Electronic GmbH. All rights reserved.
*
*	Bitte beachten Sie, dass dieses Programm nur uneingeschrnkt fr nicht kommerzielle Zwecke genutzt 
*	werden darf. Ich bernehme keine Garantie fr die einwandfreie Funktion dieses Programmes und ber- 
*	nehme dadurch auch keine Haftung fr Folgeschden die Aufgrund der Benutzung dieser Daten entstehen. 
*	Dieses gilt auch dann, wenn ich ber einen solchen Schaden unterrichtet worden bin. 
*/

#ifndef RFM_H_
#define RFM_H_

#include "rfm75.h"

/* Module settings */
#define MODULE_CONFIG		( (1<<MASK_RX_DR) | (1<<EN_CRC) | (0<<CRCO) )
#define MODULE_CONFIG_RX	( (0<<MASK_RX_DR) | (1<<MASK_TX_DS) | (1<<MASK_MAX_RT) | (1<<EN_CRC) | (0<<CRCO) )
#define MODULE_CHANNEL		2
#define MODULE_PAYLOAD		8
#define MODULE_RF_SETUP		0x07
#define MODULE_TX_NR_0		0

/* Set register for RX or TX */
#define TX_POWERUP			rfm_writeRegister(CONFIG, MODULE_CONFIG | ( (1<<PWR_UP) | (0<<PRIM_RX) ))
#define RX_POWERUP			rfm_writeRegister(CONFIG, MODULE_CONFIG_RX | ( (1<<PWR_UP) | (1<<PRIM_RX) ))

uint8_t rfm_PTX;
uint8_t rfm_sendCounter;

uint8_t buffer[1];

void rfm_init(void);
void rfm_select (void);
void rfm_deselect (void);
void rfm_writeRegister (uint8_t reg, uint8_t value);
uint8_t rfm_readRegister (uint8_t reg);
void rfm_writeRegisterArray (uint8_t reg, uint8_t * array, uint8_t len);
void rfm_writePayload (uint8_t * array, uint8_t len);
void rfm_readPayload (uint8_t * array, uint8_t len);
uint8_t rfm_getStatus (void);
void rfm_sendArray (uint8_t * array, uint8_t len);
void rfm_configTX (uint8_t tx_nr);
void rfm_configRX (void);
void rfm_handler(uint32_t id, uint32_t index);
#endif /* RFM_H_ */