/*	
 *	Pollin Electronic GmbH
 *	Max-Pollin-Strae 1			
 *	85104 Pfrring 
 *	http://www.pollin.de
 *
 *	Project:	RAPITUS SAMxS Evaluationboard 
 *  Filename:	uart_menu.c
 *
 *  Author:		Leonhard Hesse
 *
 *  Copyright (c) 2016 Pollin Electronic GmbH. All rights reserved.
 *
 *  Bitte beachten Sie, dass dieses Programm nur uneingeschrnkt fr nicht kommerzielle Zwecke genutzt 
 *  werden darf. Ich bernehme keine Garantie fr die einwandfreie Funktion dieses Programmes und ber- 
 *  nehme dadurch auch keine Haftung fr Folgeschden die Aufgrund der Benutzung dieser Daten entstehen. 
 *  Dieses gilt auch dann, wenn ich ber einen solchen Schaden unterrichtet worden bin. 
 */

 #include "asf.h"
 #include "user.h"
 #include "lcd.h"
 #include "uart.h"
 #include "uart_menu.h"
 #include "rtc.h"
 #include "string.h"
 #include "dcf.h"
 #include "buttons_adc.h"

 #if defined RFM_ADDON && defined RFM_TRANSMITTER
	bool rfm_transmitter = true;
	bool rfm_receiver = false;
 #elif defined RFM_ADDON && defined RFM_RECEIVER
	bool rfm_transmitter = false;
	bool rfm_receiver = true;
 #else
	bool rfm_transmitter = false;
	bool rfm_receiver = false;
 #endif
 #ifdef DCF_ADDON
	bool dcf_used = true;
 #else
	bool dcf_used = false;
 #endif	

 static uint8_t minute_u;
 static uint8_t minute_t;
 static uint8_t hour_u;
 static uint8_t hour_t;
 static uint8_t day_u;
 static uint8_t day_t;
 static uint8_t month_u;
 static uint8_t month_t;
 static uint8_t year_u;
 static uint8_t year_t;
 static uint8_t year_h;
 static uint8_t year_k;

 static uint32_t uart_year;
 static uint32_t uart_month;
 static uint32_t uart_day;
 static uint32_t uart_hour;
 static uint32_t uart_minute;
 static uint32_t dummy;

 void show_UART_MainMenu (void)
 {
	uart_selMenu = 0;
	uart_selSubMenu = 0;
	uart_selSubSubMenu = 0;
	uart_subMenu = false;
	uart_showDataJ3 = false;
	uart_updateTimeAndDate = false;
	uart_dcfActive = false;
	uart_timeInputCounter = 0;
	uart_Menu_aktive = true;
	uart_sendDataRFM = false;
	uart_receiveDataRFM = false;
	dcf_stop();

	cursor_gotoxy('0','0','0','0');
	clearScreen();
	uart_write_string(UART0, "=================================================================\r");
	uart_write_string(UART0, "=           Copyright (c) 2016 Pollin Electronic GmbH           =\r");
	uart_write_string(UART0, "=                                                               =\r");
	uart_write_string(UART0, "=                 RAPITUS-SAMxS-Evaluationboard                 =\r");
	uart_write_string(UART0, "=================================================================\r\n");
	uart_write_string(UART0, "=========================== Main Menu ===========================\r");
	uart_write_string(UART0, "=                                                               =\r");
	uart_write_string(UART0, "=   LEDs          - Change the current condition ------------ 1 =\r");
	uart_write_string(UART0, "=   Buzzer        - Play an squeaky sound ------------------- 2 =\r");
	uart_write_string(UART0, "=   RS232         - Send or receive some data on J3 --------- 3 =\r");
	uart_write_string(UART0, "=   Time settings - Change or get the system time ----------- 4 =\r");
	if (rfm_transmitter == true)
	{
		uart_write_string(UART0, "=   RFM75         - Send data via RFM ----------------------- 5 =\r");
	}
	else if (rfm_receiver == true)
	{
		uart_write_string(UART0, "=   RFM75         - Receive data via RFM -------------------- 5 =\r");
	}
	uart_write_string(UART0, "=                                                               =\r");
	uart_write_string(UART0, "=================================================================\r\n");
	uart_write_string(UART0, "Please enter your choice: ");
 }

 void uart_getMenuChoice (uint8_t choice)
 {
 	if (choice == 5)
 	{
		show_LCD_MainMenu();
		if (uart_selMenu != 0)
		{
	 		show_UART_MainMenu();
		}
 	}

 	if (uart_subMenu == false && uart_selSubSubMenu == 0)
 	{
		switch (choice)
		{
			case '1':
			cursor_gotoxy('0','0','0','7');
			clearScreen();
			uart_write_string(UART0, "=============================== LEDs ============================\r");
			uart_write_string(UART0, "=                                                               =\r");
			uart_write_string(UART0, "=   Toggle LED1          ------------------------------------ 1 =\r");
			uart_write_string(UART0, "=   Toggle LED2          ------------------------------------ 2 =\r");
			uart_write_string(UART0, "=   Toggle LED1 & LED2   ------------------------------------ 3 =\r");
			uart_write_string(UART0, "=   Exit                 ------------------------------- Strg+E =\r");
			uart_write_string(UART0, "=                                                               =\r");
			uart_write_string(UART0, "=================================================================\r\n");
			uart_write_string(UART0, "Please enter your choice: ");
			uart_subMenu = true;
			uart_selMenu = UART_MENU_LED;
			if (lcd_subMenu == false)
			{
				changeTheLcdMenu(MENU_LED);
			}
			break;

			case '2':
			cursor_gotoxy('0','0','0','7');
			clearScreen();
			uart_write_string(UART0, "============================== Buzzer ===========================\r");
			uart_write_string(UART0, "=                                                               =\r");
			uart_write_string(UART0, "=   Start playing sound  ------------------------------------ 1 =\r");
			uart_write_string(UART0, "=   Stop playing sound   ------------------------------------ 2 =\r");
			uart_write_string(UART0, "=   Exit                 ------------------------------- Strg+E =\r");
			uart_write_string(UART0, "=                                                               =\r");
			uart_write_string(UART0, "=================================================================\r\n");
			uart_write_string(UART0, "Please enter your choice: ");
			uart_subMenu = true;
			uart_selMenu = UART_MENU_BUZZER;
			if (lcd_subMenu == false)
			{
				changeTheLcdMenu(MENU_SUMMER);
			}
			break;

			case '3':
			cursor_gotoxy('0','0','0','7');
			clearScreen();
			uart_write_string(UART0, "============================= RS232 J3 ==========================\r");
			uart_write_string(UART0, "=                                                               =\r");
			uart_write_string(UART0, "=   Send some data on J3  ----------------------------------- 1 =\r");
			uart_write_string(UART0, "=   Receive data on J3    ----------------------------------- 2 =\r");
			uart_write_string(UART0, "=   Exit                  ------------------------------ Strg+E =\r");
			uart_write_string(UART0, "=                                                               =\r");
			uart_write_string(UART0, "=================================================================\r\n");
			uart_write_string(UART0, "Please enter your choice: ");
			uart_subMenu = true;
			uart_selMenu = UART_MENU_RS232;
			break;

			case '4':
			cursor_gotoxy('0','0','0','7');
			clearScreen();
			uart_write_string(UART0, "========================== Time Settings ========================\r");
			uart_write_string(UART0, "=                                                               =\r");
			uart_write_string(UART0, "=   Show time & date      ----------------------------------- 1 =\r");
			uart_write_string(UART0, "=   Settings manual       ----------------------------------- 2 =\r");
			if (dcf_used == true)
			{
				uart_write_string(UART0, "=   Settings via DCF      ----------------------------------- 3 =\r");
			}
			uart_write_string(UART0, "=   Exit                  ------------------------------ Strg+E =\r");
			uart_write_string(UART0, "=                                                               =\r");
			uart_write_string(UART0, "=================================================================\r\n");
			uart_write_string(UART0, "Please enter your choice: ");
			uart_subMenu = true;
			uart_selMenu = UART_MENU_TIME;
			if (lcd_subMenu == false)
			{
				changeTheLcdMenu(MENU_TIME);
			}
			break;

			case '5':
			if (rfm_transmitter == true)
			{			
				cursor_gotoxy('0','0','0','7');
				clearScreen();
				uart_write_string(UART0, "============================== RFM75 ============================\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=           Type something to send via the RFM module.          =\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=   Exit                  ------------------------------ Strg+E =\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=================================================================\r\n");
				uart_write_string(UART0, "Please tell me some data to send: ");
				uart_subMenu = true;
				uart_selMenu = UART_MENU_RFM;
			}
			else if (rfm_receiver == true)
			{
				cursor_gotoxy('0','0','0','7');
				clearScreen();
				uart_write_string(UART0, "============================== RFM75 ============================\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=     Receiving mode enabled. Below you can see the result.     =\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=   Exit                  ------------------------------ Strg+E =\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=================================================================\r\n");
				uart_write_string(UART0, "Received data via RFM: ");
				uart_subMenu = true;
				uart_selMenu = UART_MENU_RFM;
				if (rfm_receiver == true)
				{
					uart_receiveDataRFM = true;
				}
			}
			break;
		}
	}

	else if (uart_subMenu == true && uart_selSubSubMenu == 0)
	{
		switch (uart_selMenu)
		{
			case UART_MENU_LED:
			switch (choice)
			{
				case '1':
				gpio_toggle_pin(LED1);
				break;
				case '2':
				gpio_toggle_pin(LED2);
				break;
				case '3':
				gpio_toggle_pin(LED1);
				gpio_toggle_pin(LED2);
				break;
			}
			break;

			case UART_MENU_BUZZER:
			switch (choice)
			{
				case '1':
				summerStart = true;
				break;
				case '2':
				summerStart = false;
				break;
			}
			break;
			
			case UART_MENU_RS232:
			switch (choice)
			{
				case '1':
				uart_write_string(UART1, "Hello! My name is Sam. ");
				break;
				case '2':
				uart_showDataJ3 = true;
				uart_write_string(UART0, "\r\n");
				uart_write_string(UART0, "Received data on J3: ");
				break;
			}
			break;

			case UART_MENU_TIME:
			switch (choice)
			{
				case '1':
				cursor_gotoxy('0','0','0','7');
				clearScreen();
				uart_write_string(UART0, "=========================== Time & Date =========================\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=   Change time & date manual   ----------------------------- 1 =\r");
				if (dcf_used == true)
				{
					uart_write_string(UART0, "=   Get time & date via DCF     ----------------------------- 2 =\r");
				}
				uart_write_string(UART0, "=   Exit                        ------------------------ Strg+E =\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=================================================================\r\n");
				uart_write_string(UART0, "Please enter your choice: ");
				rtc_update();
				uart_updateTimeAndDate = true;
				uart_selSubSubMenu = 1;
				uart_selSubMenu = UART_SUBMENU_SHOWTIME;
				lcd_showTime = true;
				break;

				case '2':
				lcd_showTime = false;
				changeTheLcdMenu(MENU_TIME);
				cursor_gotoxy('0','0','0','7');
				clearScreen();
				uart_write_string(UART0, "====================== Time & Date Settings =====================\r");
				uart_write_string(UART0, "============================= Weekday ===========================\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=   Monday       -------- 1            Friday      -------- 5   =\r");
				uart_write_string(UART0, "=   Tuesday      -------- 2            Saturday    -------- 6   =\r");
				uart_write_string(UART0, "=   Wednesday    -------- 3            Sunday      -------- 7   =\r");
				uart_write_string(UART0, "=   Thursday     -------- 4            Exit        --- Strg+E   =\r");
				uart_write_string(UART0, "=                                                               =\r");
				uart_write_string(UART0, "=================================================================\r\n");
				uart_write_string(UART0, "Please tell me the current weekday: ");
				uart_selSubSubMenu = 1;
				uart_selSubMenu = UART_SUBMENU_CHANGETIME;
				break;

				case '3':
					if (dcf_used == true)
					{
						lcd_showTime = false;
						changeTheLcdMenu(MENU_TIME);
						cursor_gotoxy('0','0','0','7');
						clearScreen();
						uart_write_string(UART0, "===================== Using the DCF Receiver ====================\r");
						uart_write_string(UART0, "=                                                               =\r");
						uart_write_string(UART0, "=             Below you can see the signal quality.             =\r");
						uart_write_string(UART0, "=              I need to receive 10 valid signals               =\r");
						uart_write_string(UART0, "=         before I will try to get time and date by DCF.        =\r");
						uart_write_string(UART0, "=                                                               =\r");
						uart_write_string(UART0, "=                                                               =\r");
						uart_write_string(UART0, "=                                                               =\r");
						uart_write_string(UART0, "=   Exit                  ------------------------------ Strg+E =\r");
						uart_write_string(UART0, "=                                                               =\r");
						uart_write_string(UART0, "=================================================================\r\n");
						uart_write_string(UART0, "Please enter your choice: ");
						uart_dcfActive = true;
						doOnlyOnce = 0;
						lcd_subSubMenu = true;
						lcd_selSubSubMenu = 1;
						dcf_init();
					}
				break;
			}
			break;

			case UART_MENU_RFM:
				if (rfm_transmitter == true)
				{
					uart_sendDataRFM = true;
				}			
			break;
		}
	}

	else if (uart_selSubSubMenu > 0)
	{
		switch (uart_selMenu)
		{
			case UART_MENU_TIME:
			switch (uart_selSubMenu)
			{
				case UART_SUBMENU_SHOWTIME:
				switch (choice)
				{
					case '1':
					uart_selSubSubMenu = 0;
					uart_updateTimeAndDate = false;
					uart_getMenuChoice('2');
					break;
					
					case '2':
						if (dcf_used == true)
						{
							uart_selSubSubMenu = 0;
							uart_updateTimeAndDate = false;
							uart_getMenuChoice('3');
						}
					break;
				}
				break;

				case UART_SUBMENU_CHANGETIME: 
				switch (uart_selSubSubMenu)
				{
					case 1:	//weekday setting
					uart_manualWeekday = choice - 48;
					rtc_set_date(RTC, 1, 1, 2010, uart_manualWeekday);
					uart_selSubSubMenu++;
					uart_week = 0;
					rtc_get_date(RTC, &dummy, &dummy, &dummy, &uart_week);
					cursor_gotoxy('0','0','0','8');
					clearScreen();
					uart_write_string(UART0, "============================== Date =============================\r");
					uart_write_string(UART0, "=                                                               =\r");
					uart_write_string(UART0, "=                          Nice to know!                        =\r");
					switch (uart_week)
					{
						case 1:
						uart_write_string(UART0, "=           So today is Monday. I don't like Mondays..          =\r");	break;
						case 2:
						uart_write_string(UART0, "=          So today is Tuesday. I don't like Tuesdays..         =\r");	break;
						case 3:
						uart_write_string(UART0, "=            So today is Wednesday. Thats OK for me.            =\r");	break;
						case 4:
						uart_write_string(UART0, "=            So today is Thursday. Thats OK for me.             =\r");	break;
						case 5:
						uart_write_string(UART0, "=             So today is Friday. I like Fridays :)             =\r");	break;
						case 6:
						uart_write_string(UART0, "=           So today is Saturday. I love Saturdays <3           =\r");	break;
						case 7:
						uart_write_string(UART0, "=             So today is Sunday. I like Sundays :)             =\r");	break;
					}
					uart_write_string(UART0, "=                                                               =\r");
					uart_write_string(UART0, "=              Now I need to know the date of today.            =\r");
					uart_write_string(UART0, "=                   Type like this: 01.01.2016                  =\r");
					uart_write_string(UART0, "=                                                               =\r");
					uart_write_string(UART0, "=   Exit                  ------------------------------ Strg+E =\r");
					uart_write_string(UART0, "=                                                               =\r");
					uart_write_string(UART0, "=================================================================\r\n");
					uart_write_string(UART0, "Please tell me the current date: ");
					break;

					case 2:			
					if (choice == 0x08 && uart_timeInputCounter > 0)	// Backspace
					{
						uart_write_char(UART0, choice);
						uart_timeInputCounter--;
					}
					else if (	
								( uart_timeInputCounter == 0 && (choice == '0'||choice =='1'||choice =='2'||choice =='3') ) ||			// day tens
								( (uart_timeInputCounter == 1||uart_timeInputCounter == 4||uart_timeInputCounter == 8||uart_timeInputCounter == 9) && (choice == '0'||choice =='1'||choice =='2'||choice =='3'||choice =='4'||choice =='5'||choice =='6'||choice =='7'||choice =='8'||choice =='9') ) ||	// day units, month units, year units/tens
								( uart_timeInputCounter == 3 && (choice == '0'||choice =='1') ) ||										// month tens
								( uart_timeInputCounter == 6 && choice == '2' ) ||														// year thousands
								( uart_timeInputCounter == 7 && choice == '0' ) ||														// year hundreds
								( (uart_timeInputCounter == 2 || uart_timeInputCounter ==  5) && choice == '.' )						// points
							)
					{
						uart_timeInputCounter++;
						uart_write_char(UART0, choice);
						switch (uart_timeInputCounter)
						{							
							case 1:	 day_t = choice - '0';		break;
							case 2:	 day_u = choice - '0';		break;
							case 4:	 month_t = choice - '0';	break;
							case 5:	 month_u = choice - '0';	break;
							case 7:	 year_k = choice - '0';		break;
							case 8:	 year_h = choice - '0';		break;
							case 9:  year_t = choice - '0';		break;
							case 10: year_u = choice - '0';		

							uart_day = (day_t*10) + day_u;
							uart_month = (month_t*10) + month_u;
							uart_year =  (year_k*1000) + (year_h*100) + (year_t*10) + year_u;

							rtc_set_date(RTC, uart_year, uart_month, uart_day, uart_week);
							memset(lineDate, 0, strlen(lineDate));
							sprintf(uart_year_str, "%ld", uart_year);
							sprintf(uart_month_str, "%ld", uart_month);
							sprintf(uart_day_str, "%ld", uart_day);

							cursor_gotoxy('0','0','0','8');
							clearScreen();
							uart_write_string(UART0, "============================== Time =============================\r");
							uart_write_string(UART0, "=                                                               =\r");
							uart_write_string(UART0, "=        OK, you told me the following weekday and date.        =\r");
							switch (uart_week)
							{
								case 1:
								strcat(lineDate, "Mo. ");	break;
								case 2:
								strcat(lineDate, "Tu. ");	break;
								case 3:
								strcat(lineDate, "We. ");	break;
								case 4:
								strcat(lineDate, "Th. ");	break;
								case 5:
								strcat(lineDate, "Fr. ");	break;
								case 6:
								strcat(lineDate, "Sa. ");	break;
								case 7:
								strcat(lineDate, "Su. ");	break;
							}
							if (uart_day<10){strcat(lineDate, "0");}
							strcat(lineDate, uart_day_str);
							strcat(lineDate, ".");
							if (uart_month<10){strcat(lineDate, "0");}
							strcat(lineDate, uart_month_str);
							strcat(lineDate, ".");
							strcat(lineDate, uart_year_str);
							uart_write_string(UART0, "=                        ");
							uart_write_string(UART0, lineDate);
							uart_write_string(UART0, "                         =\r");
							uart_write_string(UART0, "=      Could you now be so kind to tell me what time it is?     =\r");
							uart_write_string(UART0, "=                     Type like this: 21:30                     =\r");
							uart_write_string(UART0, "=                                                               =\r");
							uart_write_string(UART0, "=   Exit                  ------------------------------ Strg+E =\r");
							uart_write_string(UART0, "=                                                               =\r");
							uart_write_string(UART0, "=================================================================\r\n");
							uart_write_string(UART0, "Please tell me the current day time: ");
							uart_selSubSubMenu++;
							uart_timeInputCounter = 0;
							break;
						}
					}
					break;

					case 3:
					if (choice == 0x08 && uart_timeInputCounter > 0)	// Backspace
					{
						uart_write_char(UART0, choice);
						uart_timeInputCounter--;
					}
					else if ( 
								( uart_timeInputCounter == 0 && (choice == '0' || choice == '1' || choice == '2') ) ||		// hour tens
								( (uart_timeInputCounter == 1 || uart_timeInputCounter == 4)  && (choice == '0' || choice == '1' || choice == '2' || choice == '3' || choice == '4' || choice == '5' || choice == '6' || choice == '7' || choice == '8' || choice == '9') ) ||	// hour units, minutes units
								( uart_timeInputCounter == 3 && (choice == '0' || choice == '1' || choice == '2' || choice == '3' || choice == '4' || choice == '5') ) ||	// minutes tens
								( uart_timeInputCounter == 2 && choice == ':' )		// colon
							)
					{
						uart_write_char(UART0, choice);
						uart_timeInputCounter++;

						switch (uart_timeInputCounter)
						{
							case 1:	 hour_t = (choice - '0');	break;
							case 2:	 hour_u = choice - '0';		break;
							case 4:	 minute_t = (choice - '0');	break;
							case 5:	 minute_u = choice - '0';	
							uart_hour = hour_t*10 + hour_u;
							uart_minute = minute_t*10 + minute_u;
							rtc_set_time(RTC, uart_hour, uart_minute, 0);
							uart_selSubSubMenu = 0;
							uart_timeInputCounter = 0;
							uart_getMenuChoice('1');
							break;
						}
					}
					break;
				}
				break;			
			}
			break;
		}
	}
 }

 void cursor_gotoxy(int x1, int x2, int y1, int y2)
 {
	 uart_write_char(UART0, 0x1b);
	 uart_write_char(UART0,'[');
	 uart_write_char(UART0,y1);
	 uart_write_char(UART0,y2);
	 uart_write_char(UART0,';');
	 uart_write_char(UART0,x1);
	 uart_write_char(UART0,x2);
	 uart_write_char(UART0,'H');
 }

 void clearScreen (void)
 {
	uart_write_char(UART0, 0x1b);
	uart_write_char(UART0,'[');
	uart_write_char(UART0,'J');
 }

 void uart_updateTimeDate (void)
 {	
	memset(timeAndDate, 0, strlen(timeAndDate));
	strcat(timeAndDate, date_str);
	strcat(timeAndDate, "     ");
	strcat(timeAndDate, time_str);
	strcat(timeAndDate, " Uhr");
	cursor_gotoxy('1','8','0','9');
	uart_write_string(UART0, timeAndDate);
	if (dcf_used)
	{
		cursor_gotoxy('2','7','1','7');  
	}
	else
	{
		cursor_gotoxy('2','7','1','6'); 
	}                               
 }

 void uart_writeTestProcess(const char validSig[3], const char sigCount[3])
 {
	char line[17];
	memset(line, 0, strlen(line));
	strcat(line, "I received: ");
	strcat(line, validSig);
	strcat(line, "/");
	strcat(line, sigCount);
	cursor_gotoxy('0','0','1','3');
	uart_write_string(UART0, "=                                                               =");
	cursor_gotoxy('2','7','1','3');
	uart_write_string(UART0, line);
	cursor_gotoxy('2','7','1','9'); 
 }

 void uart_writeTestFailed (const char wait[3])
 {
	cursor_gotoxy('0','0','1','3');
	uart_write_string(UART0, "=  Bad Signal :(  Please move me somewhere else! I will wait    =");
	cursor_gotoxy('6','2','1','3');
	uart_write_string(UART0, wait);
	cursor_gotoxy('2','7','1','9'); 
 }

 void uart_writeWaitSync (void)
 {
	cursor_gotoxy('0','0','1','3');
	uart_write_string(UART0, "=                  Signal OK! Wait for sync...                  =");
	cursor_gotoxy('2','7','1','9'); 
 }

 void uart_writeSyncRequ (void)
 {
	cursor_gotoxy('0','0','1','3');
	uart_write_string(UART0, "=         Invalid data. Sync required. Wait for sync...         =");
	cursor_gotoxy('2','7','1','9'); 
 }

 void uart_writeSynced (void)
 {
	cursor_gotoxy('0','0','1','3');
	uart_write_string(UART0, "=           DCF-Signal is synced. Now wait for data...          =");
	cursor_gotoxy('2','7','1','9'); 
 }

 void uart_writeDataInvalid (void)
 {
	cursor_gotoxy('0','0','1','3');
	uart_write_string(UART0, "=            Some data invalid. Wait for data again...          =");
	cursor_gotoxy('2','7','1','9'); 
 }

 void uart_showReceivedData (void)
 {
	if (doOnlyOnce == 0)
	{
		dcf_stop();
		doOnlyOnce++;
		uart_updateTimeAndDate = true;
		uart_selSubSubMenu = 0;
		uart_selMenu = UART_MENU_TIME;
		uart_getMenuChoice('1');
	}
 }

 void changeTheLcdMenu (uint8_t menu)
 {
	lcd_subMenu = false;
	lcd_subSubMenu = false;
	lcd_lastMenu = false;
	lcd_selMenu = menu;
	manageMenu(BUTTON_RETURN);
 }