/*	
 *	Pollin Electronic GmbH
 *	Max-Pollin-Strae 1			
 *	85104 Pfrring 
 *	http://www.pollin.de
 *
 *	Project:	RAPITUS SAMxS Evaluationboard 
 *  Filename:	uart_menu.h
 *
 *  Author:		Leonhard Hesse
 *
 *  Copyright (c) 2016 Pollin Electronic GmbH. All rights reserved.
 *
 *  Bitte beachten Sie, dass dieses Programm nur uneingeschrnkt fr nicht kommerzielle Zwecke genutzt 
 *  werden darf. Ich bernehme keine Garantie fr die einwandfreie Funktion dieses Programmes und ber- 
 *  nehme dadurch auch keine Haftung fr Folgeschden die Aufgrund der Benutzung dieser Daten entstehen. 
 *  Dieses gilt auch dann, wenn ich ber einen solchen Schaden unterrichtet worden bin. 
 */

#ifndef UART_MENU_H_
#define UART_MENU_H_

#define UART_MENU_LED			1
#define UART_MENU_BUZZER		2
#define UART_MENU_RS232			3
#define UART_MENU_TIME			4
#define UART_MENU_RFM			5

#define UART_SUBMENU_SHOWTIME	1
#define UART_SUBMENU_CHANGETIME	2

void show_UART_MainMenu (void);
void uart_getMenuChoice (uint8_t choice);
void cursor_gotoxy (int x1, int x2, int y1, int y2);
void clearScreen (void);
void uart_updateTimeDate (void);
void uart_writeTestProcess(const char validSig[], const char sigCount[]);
void uart_writeTestFailed (const char wait[]);
void uart_writeWaitSync (void);
void uart_writeSyncRequ (void);
void uart_writeSynced (void);
void uart_writeDataInvalid (void);
void uart_showReceivedData (void);
void changeTheLcdMenu (uint8_t menu);

uint8_t uart_selMenu;
uint8_t uart_selSubMenu;
uint8_t uart_selSubSubMenu;
uint8_t uart_timeInputCounter;

uint32_t uart_week;
uint32_t uart_manualWeekday;

char timeAndDate[35];
char lineDate[14];

char uart_year_str[4];
char uart_month_str[2];
char uart_day_str[2];

bool uart_Menu_aktive;
bool uart_subMenu;
bool uart_showDataJ3;
bool uart_updateTimeAndDate;
bool uart_dcfActive;
bool uart_sendDataRFM;
bool uart_receiveDataRFM;

#endif /* UART_MENU_H_ */